



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>php分享三十三：常量</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">php分享三十三：常量</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 05:55:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一：常量定义</strong></p>
<p>1：在脚本执行期间该值不能改变（除了所谓的<a href="http://php.net/manual/zh/language.constants.predefined.php" rel="external nofollow noreferrer">魔术常量</a>，它们其实不是常量）</p>
<p>2：常量默认为大小写敏感</p>
<p>3：命名规则：用正则表达式是这样表达的：<em>[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*</em></p>
<p>在这里，字母指的是 a-z，A-Z，以及从 127 到 255（0x7f-0xff）的 ASCII 字符。</p>
<p>4：</p>
<p>如果使用了一个未定义的常量，PHP 假定想要的是该常量本身的名字，如同用字符串调用它一样（CONSTANT 对应 "CONSTANT"）。此时将发出一个&nbsp;<a href="http://php.net/manual/zh/ref.errorfunc.php" rel="external nofollow noreferrer">E_NOTICE</a>&nbsp;级的错误。参见手册中为什么&nbsp;<a href="http://php.net/manual/zh/language.types.array.php#language.types.array.foo-bar" rel="external nofollow noreferrer">$foo[bar]</a>&nbsp;是错误的（除非事先用&nbsp;<a href="http://php.net/manual/zh/function.define.php" rel="external nofollow noreferrer">define()</a>将&nbsp;<em>bar</em>&nbsp;定义为一个常量）。如果只想检查是否定义了某常量，用&nbsp;<a href="http://php.net/manual/zh/function.defined.php" rel="external nofollow noreferrer">defined()</a>&nbsp;函数。</p>
<div>
<pre class="prettyprint linenums">settings.php<br />
&lt;?php<br />
// Debug mode<br />
define('DEBUG',false);<br />
?&gt;

test.php<br />
&lt;?php<br />
include('settings.php');

if (DEBUG) {<br />
   // echo some sensitive data.<br />
}<br />
?&gt;
</pre>
</div>
<p>If for some reason settings.php doesn't get included and the DEBUG constant is not set, PHP will STILL print the sensitive data. The solution is to evaluate it. Like so:</p>
<div>
<pre class="prettyprint linenums">settings.php<br />
&lt;?php<br />
// Debug mode<br />
define('DEBUG',0);<br />
?&gt;

test.php<br />
&lt;?php<br />
include('settings.php');

if (DEBUG == 1) {<br />
   // echo some sensitive data.<br />
}<br />
?&gt;
</pre>
</div>
<p>5：heredoc中的常量不能被解释，如果需要调用，可以把常量封装到一个函数里，返回调用</p>
<div>
<pre class="prettyprint linenums">There is a way to access a constant in heredoc.<br />
Here is the example:<br />
&lt;?php

define("__STR",'constant.string.defined');

function heredocGetConstant($constant) {<br />
  return constant($constant);<br />
}

$heredocGetConstant = 'heredocGetConstant';

$my_string = &lt;&lt;&lt;EOT<br />
This is my constant printed from heredoc: {$heredocGetConstant('__STR')}<br />
EOT;

echo $my_string;

Output:<br />
This is my constant printed from heredoc: constant.string.defined
</pre>
</div>
<p>6：It is perfectly valid to use a built-in PHP keyword as a constant name - as long as you the constant() function to retrieve it later:</p>
<div>
<pre class="prettyprint linenums">define('echo', 'My constant value');

echo constant('echo'); // outputs 'My constant value'
</pre>
</div>
<p>7：动态的常量可以用<a href="http://php.net/manual/zh/function.constant.php" rel="external nofollow noreferrer">constant()</a>返回</p>
<p>8：常量和（全局）变量在不同的名字空间中。这意味着例如&nbsp;<strong><code>TRUE</code></strong>&nbsp;和&nbsp;<var><var>$TRUE</var></var>&nbsp;是不同的。</p>
<p><strong>二：魔术常量(8个）<br /></strong></p>
<pre class="prettyprint linenums">__FUNCTION__; __FILE__; __LINE__; __NAMESPACE__; __TRAIT__; __CLASS__; __METHOD__; __DIR__;</pre>
<p>二：类常量const</p>
<p>1：接口（interface）中也可以定义常量</p>
<p>2：从php5.6开始常量可以用标量表单式了</p>
<p>3：类常量可以被覆盖</p>
<p>it's possible to declare constant in base class, and override it in child, and access to correct value of the const from the static method is possible by 'get_called_class' method:</p>
<div>
<pre class="prettyprint linenums">abstract class dbObject<br />
{<br />
    const TABLE_NAME='undefined';

    public static function GetAll()<br />
    {<br />
        $c = get_called_class();<br />
        return "SELECT * FROM `".$c::TABLE_NAME."`";<br />
    }<br />
}

class dbPerson extends dbObject<br />
{<br />
    const TABLE_NAME='persons';<br />
}

class dbAdmin extends dbPerson<br />
{<br />
    const TABLE_NAME='admins';<br />
}

echo dbPerson::GetAll()."&lt;br&gt;";//output: "SELECT * FROM `persons`"<br />
echo dbAdmin::GetAll()."&lt;br&gt;";//output: "SELECT * FROM `admins`"
</pre>
</div>
<p>二：const和define定义常量的区别</p>
<p>1：和使用&nbsp;<a href="http://php.net/manual/zh/function.define.php" rel="external nofollow noreferrer">define()</a>&nbsp;来定义常量相反的是，使用&nbsp;<em>const</em>&nbsp;关键字定义常量必须处于最顶端的作用区域，因为用此方法是在编译时定义的。这就意味着不能在函数内，循环内以及&nbsp;<em>if</em>&nbsp;语句之内用&nbsp;<em>const</em>&nbsp;来定义常量。</p>
<p>2：类常量中不能有变量，define中可以用</p>
<div>
<pre class="prettyprint linenums">The const keyword will not allow anything that may have to be "processed":

$color = "red";<br />
const RED = "This is the color $color"; //Doesn't work<br />
define(strtoupper($color), "This is the color $color") // Works fine
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o4705q.html">Servlet和JSP学习指导与实践（二）：Session追踪</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyry0j8.html">Javascript 字符串常用操作方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvjrzjq.html">MATLAB的crack安装小曲</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2zwgwq.html">&lbrack;CF148E&rsqb; Porcelain &lpar;分组背包&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0egdwq.html">转载网页博客：ie7bug&colon;div容器下的img与div存在间隙</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd52dy8.html">&amp;lt&semi;meta http-equiv &equals; &amp;quot&semi;X-UA-Compatible&amp;quot&semi; cotent &equals; &amp;quot&semi;IE&equals;edge&comma;chrome&equals;1&amp;quot&semi;&sol;&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vpke48.html">【hadoop2&period;6&period;0】一句话形容mapreduce</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5xne8.html">hdu2717 Catch That Cow</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1k66g8.html">Win7系统Matlab2013a安装&period;m文件不自动关联到MATLAB&period;exe解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zvy0j9.html">智能循迹避障小车&amp;amp&semi;抢答器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5zyprq.html">shell  date命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd26ke9.html">Windows Server 2016-Windows Server Backup功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyjzdx9.html">python全栈开发day92-day96 Vue总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rl5e28.html">linux VPS服务器的一些配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gd6ovq.html">Qt 从菜单栏打开文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4r41k9.html">mvc&colon;view-controller标签使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjr6zr9.html">Linux连不上校园网怎么办？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5l00dq.html">el表达式用&equals;&equals;和eq的注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/902vnymq.html">Kali Linux没有声音的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj1k308.html">【sed】常用命令</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9prm3yq.html">Thinking in Java from Chapter 15</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zwvl38.html">Maven之打包时配置文件替换</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvlzvo8.html">JQ中  trigger&lpar;&rpar;和triggerHandler&lpar;&rpar;区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7rl1j8.html">Android 使WebView支持HTML5 Video（全屏）播放的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8evo1e9.html">GO語言視頻教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q240kv8.html">Level shifting a &plus;&sol;- 2&period;5V signal to 0 - 5V</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd2oxv9.html">多看Kindle的&OpenCurlyDoubleQuote;导出失败&comma;请检查网络或账号&rdquo;错误的解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxvejj9.html">Javacript和AngularJS中的Promises</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zw4od8.html">C&plus;&plus;多线程开发之actor model</a>
			</li>
						<li><a href="https://www.batexi.com/a/390gykj8.html">闲聊Redshift与日本CG行业的近况</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
